Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3606)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 3607)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Output of radiation-related quantities migrated to radiation_model_mod.
+! 
+! 3589 2018-11-30 15:09:51Z suehring
 ! Remove erroneous UTF encoding
 ! 
@@ -545,5 +548,5 @@
                message_string, plant_canopy, pt_surface,                       &
                rho_surface, simulated_time, spinup_time, surface_pressure,     &
-               time_since_reference_point, urban_surface
+               time_since_reference_point, urban_surface, varnamelength
 
     USE cpulog,                                                                &
@@ -899,4 +902,12 @@
     INTEGER(iwp)                                   ::  nwalls           !< number of wall surfaces in local processor
 
+!-- indices needed for RTM netcdf output subroutines
+    INTEGER(iwp), PARAMETER                        :: nd = 5
+    CHARACTER(LEN=6), DIMENSION(0:nd-1), PARAMETER :: dirname = (/ '_roof ', '_south', '_north', '_west ', '_east ' /)
+    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER     :: dirint_u = (/ iup_u, isouth_u, inorth_u, iwest_u, ieast_u /)
+    INTEGER(iwp), DIMENSION(0:nd-1), PARAMETER     :: dirint_l = (/ iup_l, isouth_l, inorth_l, iwest_l, ieast_l /)
+    INTEGER(iwp), DIMENSION(0:nd-1)                :: dirstart
+    INTEGER(iwp), DIMENSION(0:nd-1)                :: dirend
+
 !-- indices and sizes of urban and land surface models
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE,TARGET ::  surfl_l          !< coordinates of i-th local surface in local grid - surfl[:,k] = [d, z, y, x]
@@ -1065,4 +1076,22 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE            ::  rt2_dist
 
+!-- arrays for time averages
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfradnet_av    !< average of net radiation to local surface including radiation from reflections
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinsw_av      !< average of sw radiation falling to local surface including radiation from reflections
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlw_av      !< average of lw radiation falling to local surface including radiation from reflections
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinswdir_av   !< average of direct sw radiation falling to local surface
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinswdif_av   !< average of diffuse sw radiation from sky and model boundary falling to local surface
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlwdif_av   !< average of diffuse lw radiation from sky and model boundary falling to local surface
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinswref_av   !< average of sw radiation falling to surface from reflections
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinlwref_av   !< average of lw radiation falling to surface from reflections
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutsw_av     !< average of total sw radiation outgoing from nonvirtual surfaces surfaces after all reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfoutlw_av     !< average of total lw radiation outgoing from nonvirtual surfaces surfaces after all reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfins_av       !< average of array of residua of sw radiation absorbed in surface after last reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  surfinl_av       !< average of array of residua of lw radiation absorbed in surface after last reflection
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinlw_av       !< Average of pcbinlw
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinsw_av       !< Average of pcbinsw
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswdir_av    !< Average of pcbinswdir
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswdif_av    !< Average of pcbinswdif
+    REAL(wp), DIMENSION(:), ALLOCATABLE            ::  pcbinswref_av    !< Average of pcbinswref
 
 
@@ -1208,10 +1237,5 @@
            skip_time_do_radiation, time_radiation, unscheduled_radiation_calls,&
            zenith, calc_zenith, sun_direction, sun_dir_lat, sun_dir_lon,       &
-           nrefsteps, nsvfl, svf,                                              &
-           svfsurf, surfinsw, surfinlw, surfins, surfinl, surfinswdir,         &
-           surfinswdif, surfoutsw, surfoutlw, surfinlwdif, rad_sw_in_dir,      &
-           rad_sw_in_diff, rad_lw_in_diff, surfouts, surfoutl, surfoutsl,      &
-           surfoutll, idir, jdir, kdir, id, iz, iy, ix,                        &
-           surf, surfl, nsurfl, pcbinswdir, pcbinswdif, pcbinsw, pcbinlw,      &
+           idir, jdir, kdir, id, iz, iy, ix,                                   &
            iup_u, inorth_u, isouth_u, ieast_u, iwest_u,                        &
            iup_l, inorth_l, isouth_l, ieast_l, iwest_l,                        &
@@ -1219,6 +1243,6 @@
            idsvf, ndsvf, idcsf, ndcsf, kdcsf, pct,                             &
            radiation_interactions, startwall, startland, endland, endwall,     &
-           skyvf, skyvft, radiation_interactions_on, average_radiation, npcbl, &
-           pcbl
+           skyvf, skyvft, radiation_interactions_on, average_radiation
+
 
 #if defined ( __rrtmg )
@@ -1263,5 +1287,5 @@
 !> Check data output for radiation model
 !------------------------------------------------------------------------------!
-    SUBROUTINE radiation_check_data_output( var, unit, i, ilen, k )
+    SUBROUTINE radiation_check_data_output( variable, unit, i, ilen, k )
  
  
@@ -1271,95 +1295,127 @@
        IMPLICIT NONE
 
-       CHARACTER (LEN=*) ::  unit     !< 
-       CHARACTER (LEN=*) ::  var      !<
-
-       INTEGER(iwp) :: i
+       CHARACTER (LEN=*) ::  unit          !<
+       CHARACTER (LEN=*) ::  variable      !<
+
+       INTEGER(iwp) :: i, j, k, l
        INTEGER(iwp) :: ilen
-       INTEGER(iwp) :: k
-
-       SELECT CASE ( TRIM( var ) )
-
-          CASE ( 'rad_lw_cs_hr', 'rad_lw_hr', 'rad_lw_in', 'rad_lw_out', &
-                 'rad_sw_cs_hr', 'rad_sw_hr', 'rad_sw_in', 'rad_sw_out'  )
-             IF (  .NOT.  radiation  .OR.  radiation_scheme /= 'rrtmg' )  THEN
-                message_string = '"output of "' // TRIM( var ) // '" requi' // &
-                                 'res radiation = .TRUE. and ' //              &
-                                 'radiation_scheme = "rrtmg"'
-                CALL message( 'check_parameters', 'PA0406', 1, 2, 0, 6, 0 )
-             ENDIF
-             unit = 'K/h'     
-
-          CASE ( 'rad_net*', 'rrtm_aldif*', 'rrtm_aldir*', 'rrtm_asdif*',      &
-                 'rrtm_asdir*', 'rad_lw_in*', 'rad_lw_out*', 'rad_sw_in*',     &
-                 'rad_sw_out*')
-             IF ( i == 0 .AND. ilen == 0 .AND. k == 0)  THEN
-                ! Workaround for masked output (calls with i=ilen=k=0)
-                unit = 'illegal'
-                RETURN
-             ENDIF
-             IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
-                message_string = 'illegal value for data_output: "' //         &
-                                 TRIM( var ) // '" & only 2d-horizontal ' //   &
-                                 'cross sections are allowed for this value'
-                CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF (  .NOT.  radiation  .OR.  radiation_scheme /= "rrtmg" )  THEN
-                IF ( TRIM( var ) == 'rrtm_aldif*'  .OR.                        &
-                     TRIM( var ) == 'rrtm_aldir*'  .OR.                        &
-                     TRIM( var ) == 'rrtm_asdif*'  .OR.                        &
-                     TRIM( var ) == 'rrtm_asdir*'      )                       &
-                THEN
-                   message_string = 'output of "' // TRIM( var ) // '" require'&
-                                    // 's radiation = .TRUE. and radiation_sch'&
-                                    // 'eme = "rrtmg"'
-                   CALL message( 'check_parameters', 'PA0409', 1, 2, 0, 6, 0 )
-                ENDIF
-             ENDIF
-
-             IF ( TRIM( var ) == 'rad_net*'      ) unit = 'W/m2'   
-             IF ( TRIM( var ) == 'rad_lw_in*'    ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'rad_lw_out*'   ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'rad_sw_in*'    ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'rad_sw_out*'   ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'rad_sw_in'     ) unit = 'W/m2'
-             IF ( TRIM( var ) == 'rrtm_aldif*'   ) unit = ''   
-             IF ( TRIM( var ) == 'rrtm_aldir*'   ) unit = '' 
-             IF ( TRIM( var ) == 'rrtm_asdif*'   ) unit = '' 
-             IF ( TRIM( var ) == 'rrtm_asdir*'   ) unit = '' 
-
-          CASE ( 'rad_mrt', 'rad_mrt_sw', 'rad_mrt_lw'  )
-
-             IF ( i == 0 .AND. ilen == 0 .AND. k == 0)  THEN
-                ! Workaround for masked output (calls with i=ilen=k=0)
-                unit = 'illegal'
-                RETURN
-             ENDIF
-
-             IF ( .NOT.  radiation ) THEN
+       CHARACTER(LEN=varnamelength) :: var          !< TRIM(variable)
+
+       var = TRIM(variable)
+
+!--    first process diractional variables
+       IF ( var(1:12) == 'rtm_rad_net_'  .OR.  var(1:13) == 'rtm_rad_insw_'  .OR.        &
+            var(1:13) == 'rtm_rad_inlw_'  .OR.  var(1:16) == 'rtm_rad_inswdir_'  .OR.    &
+            var(1:16) == 'rtm_rad_inswdif_'  .OR.  var(1:16) == 'rtm_rad_inswref_'  .OR. &
+            var(1:16) == 'rtm_rad_inlwdif_'  .OR.  var(1:16) == 'rtm_rad_inlwref_'  .OR. &
+            var(1:14) == 'rtm_rad_outsw_'  .OR.  var(1:14) == 'rtm_rad_outlw_'  .OR.     &
+            var(1:14) == 'rtm_rad_ressw_'  .OR.  var(1:14) == 'rtm_rad_reslw_'  ) THEN
+          IF ( .NOT.  radiation ) THEN
                 message_string = 'output of "' // TRIM( var ) // '" require'&
                                  // 's radiation = .TRUE.'
                 CALL message( 'check_parameters', 'PA0509', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( mrt_nlevels == 0 ) THEN
+          ENDIF
+          unit = 'W/m2'
+       ELSE IF ( var(1:7) == 'rtm_svf'  .OR.  var(1:7) == 'rtm_dif'  .OR.                &
+                 var(1:9) == 'rtm_skyvf' .OR. var(1:9) == 'rtm_skyvft' )  THEN
+          IF ( .NOT.  radiation ) THEN
                 message_string = 'output of "' // TRIM( var ) // '" require'&
-                                 // 's mrt_nlevels > 0'
-                CALL message( 'check_parameters', 'PA0510', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'rad_mrt_sw'  .AND.  .NOT. mrt_include_sw ) THEN
-                message_string = 'output of "' // TRIM( var ) // '" require'&
-                                 // 's rad_mrt_sw = .TRUE.'
-                CALL message( 'check_parameters', 'PA0511', 1, 2, 0, 6, 0 )
-             ENDIF
-             IF ( TRIM( var ) == 'rad_mrt' ) THEN
-                unit = 'K'
-             ELSE
-                unit = 'W m-2'
-             ENDIF
-
-          CASE DEFAULT
-             unit = 'illegal'
-
-       END SELECT
-
+                                 // 's radiation = .TRUE.'
+                CALL message( 'check_parameters', 'PA0509', 1, 2, 0, 6, 0 )
+          ENDIF
+          unit = '1'
+       ELSE
+!--       non-directional variables
+          SELECT CASE ( TRIM( var ) )
+             CASE ( 'rad_lw_cs_hr', 'rad_lw_hr', 'rad_lw_in', 'rad_lw_out', &
+                    'rad_sw_cs_hr', 'rad_sw_hr', 'rad_sw_in', 'rad_sw_out'  )
+                IF (  .NOT.  radiation  .OR.  radiation_scheme /= 'rrtmg' )  THEN
+                   message_string = '"output of "' // TRIM( var ) // '" requi' // &
+                                    'res radiation = .TRUE. and ' //              &
+                                    'radiation_scheme = "rrtmg"'
+                   CALL message( 'check_parameters', 'PA0406', 1, 2, 0, 6, 0 )
+                ENDIF
+                unit = 'K/h'
+
+             CASE ( 'rad_net*', 'rrtm_aldif*', 'rrtm_aldir*', 'rrtm_asdif*',      &
+                    'rrtm_asdir*', 'rad_lw_in*', 'rad_lw_out*', 'rad_sw_in*',     &
+                    'rad_sw_out*')
+                IF ( i == 0 .AND. ilen == 0 .AND. k == 0)  THEN
+                   ! Workaround for masked output (calls with i=ilen=k=0)
+                   unit = 'illegal'
+                   RETURN
+                ENDIF
+                IF ( k == 0  .OR.  data_output(i)(ilen-2:ilen) /= '_xy' )  THEN
+                   message_string = 'illegal value for data_output: "' //         &
+                                    TRIM( var ) // '" & only 2d-horizontal ' //   &
+                                    'cross sections are allowed for this value'
+                   CALL message( 'check_parameters', 'PA0111', 1, 2, 0, 6, 0 )
+                ENDIF
+                IF (  .NOT.  radiation  .OR.  radiation_scheme /= "rrtmg" )  THEN
+                   IF ( TRIM( var ) == 'rrtm_aldif*'  .OR.                        &
+                        TRIM( var ) == 'rrtm_aldir*'  .OR.                        &
+                        TRIM( var ) == 'rrtm_asdif*'  .OR.                        &
+                        TRIM( var ) == 'rrtm_asdir*'      )                       &
+                   THEN
+                      message_string = 'output of "' // TRIM( var ) // '" require'&
+                                       // 's radiation = .TRUE. and radiation_sch'&
+                                       // 'eme = "rrtmg"'
+                      CALL message( 'check_parameters', 'PA0409', 1, 2, 0, 6, 0 )
+                   ENDIF
+                ENDIF
+
+                IF ( TRIM( var ) == 'rad_net*'      ) unit = 'W/m2'
+                IF ( TRIM( var ) == 'rad_lw_in*'    ) unit = 'W/m2'
+                IF ( TRIM( var ) == 'rad_lw_out*'   ) unit = 'W/m2'
+                IF ( TRIM( var ) == 'rad_sw_in*'    ) unit = 'W/m2'
+                IF ( TRIM( var ) == 'rad_sw_out*'   ) unit = 'W/m2'
+                IF ( TRIM( var ) == 'rad_sw_in'     ) unit = 'W/m2'
+                IF ( TRIM( var ) == 'rrtm_aldif*'   ) unit = ''
+                IF ( TRIM( var ) == 'rrtm_aldir*'   ) unit = ''
+                IF ( TRIM( var ) == 'rrtm_asdif*'   ) unit = ''
+                IF ( TRIM( var ) == 'rrtm_asdir*'   ) unit = ''
+
+             CASE ( 'rtm_rad_pc_inlw', 'rtm_rad_pc_insw', 'rtm_rad_pc_inswdir', &
+                    'rtm_rad_pc_inswdif', 'rtm_rad_pc_inswref')
+                IF ( .NOT.  radiation ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" require'&
+                                    // 's radiation = .TRUE.'
+                   CALL message( 'check_parameters', 'PA0509', 1, 2, 0, 6, 0 )
+                ENDIF
+                unit = 'W'
+
+             CASE ( 'rtm_mrt', 'rtm_mrt_sw', 'rtm_mrt_lw'  )
+                IF ( i == 0 .AND. ilen == 0 .AND. k == 0)  THEN
+                   ! Workaround for masked output (calls with i=ilen=k=0)
+                   unit = 'illegal'
+                   RETURN
+                ENDIF
+
+                IF ( .NOT.  radiation ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" require'&
+                                    // 's radiation = .TRUE.'
+                   CALL message( 'check_parameters', 'PA0509', 1, 2, 0, 6, 0 )
+                ENDIF
+                IF ( mrt_nlevels == 0 ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" require'&
+                                    // 's mrt_nlevels > 0'
+                   CALL message( 'check_parameters', 'PA0510', 1, 2, 0, 6, 0 )
+                ENDIF
+                IF ( TRIM( var ) == 'rtm_mrt_sw'  .AND.  .NOT. mrt_include_sw ) THEN
+                   message_string = 'output of "' // TRIM( var ) // '" require'&
+                                    // 's rtm_mrt_sw = .TRUE.'
+                   CALL message( 'check_parameters', 'PA0511', 1, 2, 0, 6, 0 )
+                ENDIF
+                IF ( TRIM( var ) == 'rtm_mrt' ) THEN
+                   unit = 'K'
+                ELSE
+                   unit = 'W m-2'
+                ENDIF
+
+             CASE DEFAULT
+                unit = 'illegal'
+
+          END SELECT
+       ENDIF
 
     END SUBROUTINE radiation_check_data_output
@@ -5826,4 +5882,6 @@
        endwall = nsurfl
        nwalls  = endwall - startwall + 1
+       dirstart = (/ startland, startwall, startwall, startwall, startwall /)
+       dirend = (/ endland, endwall, endwall, endwall, endwall /)
 
 !--    fill gridpcbl and pcbl
@@ -8656,8 +8714,30 @@
     INTEGER(iwp) ::  l, m !< index of current surface element
 
+    INTEGER(iwp)                                       :: ids, idsint_u, idsint_l, isurf
+    CHARACTER(LEN=varnamelength)                       :: var
+
+!-- find the real name of the variable
+    ids = -1
+    l = -1
+    var = TRIM(variable)
+    DO i = 0, nd-1
+        k = len(TRIM(var))
+        j = len(TRIM(dirname(i)))
+        IF ( TRIM(var(k-j+1:k)) == TRIM(dirname(i)) )  THEN
+            ids = i
+            idsint_u = dirint_u(ids)
+            idsint_l = dirint_l(ids)
+            var = var(:k-j)
+            EXIT
+        ENDIF
+    ENDDO
+    IF ( ids == -1 )  THEN
+        var = TRIM(variable)
+    ENDIF
+
     IF ( mode == 'allocate' )  THEN
 
-       SELECT CASE ( TRIM( variable ) )
-
+       SELECT CASE ( TRIM( var ) )
+!--          block of large scale (e.g. RRTMG) radiation output variables
              CASE ( 'rad_net*' )
                 IF ( .NOT. ALLOCATED( rad_net_av ) )  THEN
@@ -8738,5 +8818,124 @@
                 rad_sw_hr_av = 0.0_wp
 
-             CASE ( 'rad_mrt_sw' )
+!--          block of RTM output variables
+             CASE ( 'rtm_rad_net' )
+!--              array of complete radiation balance
+                 IF ( .NOT.  ALLOCATED(surfradnet_av) )  THEN
+                     ALLOCATE( surfradnet_av(nsurfl) )
+                     surfradnet_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_insw' )
+!--                 array of sw radiation falling to surface after i-th reflection
+                 IF ( .NOT.  ALLOCATED(surfinsw_av) )  THEN
+                     ALLOCATE( surfinsw_av(nsurfl) )
+                     surfinsw_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_inlw' )
+!--                 array of lw radiation falling to surface after i-th reflection
+                 IF ( .NOT.  ALLOCATED(surfinlw_av) )  THEN
+                     ALLOCATE( surfinlw_av(nsurfl) )
+                     surfinlw_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_inswdir' )
+!--                 array of direct sw radiation falling to surface from sun
+                 IF ( .NOT.  ALLOCATED(surfinswdir_av) )  THEN
+                     ALLOCATE( surfinswdir_av(nsurfl) )
+                     surfinswdir_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_inswdif' )
+!--                 array of difusion sw radiation falling to surface from sky and borders of the domain
+                 IF ( .NOT.  ALLOCATED(surfinswdif_av) )  THEN
+                     ALLOCATE( surfinswdif_av(nsurfl) )
+                     surfinswdif_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_inswref' )
+!--                 array of sw radiation falling to surface from reflections
+                 IF ( .NOT.  ALLOCATED(surfinswref_av) )  THEN
+                     ALLOCATE( surfinswref_av(nsurfl) )
+                     surfinswref_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_inlwdif' )
+!--                 array of sw radiation falling to surface after i-th reflection
+                IF ( .NOT.  ALLOCATED(surfinlwdif_av) )  THEN
+                     ALLOCATE( surfinlwdif_av(nsurfl) )
+                     surfinlwdif_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_inlwref' )
+!--                 array of lw radiation falling to surface from reflections
+                 IF ( .NOT.  ALLOCATED(surfinlwref_av) )  THEN
+                     ALLOCATE( surfinlwref_av(nsurfl) )
+                     surfinlwref_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_outsw' )
+!--                 array of sw radiation emitted from surface after i-th reflection
+                 IF ( .NOT.  ALLOCATED(surfoutsw_av) )  THEN
+                     ALLOCATE( surfoutsw_av(nsurfl) )
+                     surfoutsw_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_outlw' )
+!--                 array of lw radiation emitted from surface after i-th reflection
+                 IF ( .NOT.  ALLOCATED(surfoutlw_av) )  THEN
+                     ALLOCATE( surfoutlw_av(nsurfl) )
+                     surfoutlw_av = 0.0_wp
+                 ENDIF
+             CASE ( 'rtm_rad_ressw' )
+!--                 array of residua of sw radiation absorbed in surface after last reflection
+                 IF ( .NOT.  ALLOCATED(surfins_av) )  THEN
+                     ALLOCATE( surfins_av(nsurfl) )
+                     surfins_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_reslw' )
+!--                 array of residua of lw radiation absorbed in surface after last reflection
+                 IF ( .NOT.  ALLOCATED(surfinl_av) )  THEN
+                     ALLOCATE( surfinl_av(nsurfl) )
+                     surfinl_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_pc_inlw' )
+!--                 array of of lw radiation absorbed in plant canopy
+                 IF ( .NOT.  ALLOCATED(pcbinlw_av) )  THEN
+                     ALLOCATE( pcbinlw_av(1:npcbl) )
+                     pcbinlw_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_pc_insw' )
+!--                 array of of sw radiation absorbed in plant canopy
+                 IF ( .NOT.  ALLOCATED(pcbinsw_av) )  THEN
+                     ALLOCATE( pcbinsw_av(1:npcbl) )
+                     pcbinsw_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_pc_inswdir' )
+!--                 array of of direct sw radiation absorbed in plant canopy
+                 IF ( .NOT.  ALLOCATED(pcbinswdir_av) )  THEN
+                     ALLOCATE( pcbinswdir_av(1:npcbl) )
+                     pcbinswdir_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_pc_inswdif' )
+!--                 array of of diffuse sw radiation absorbed in plant canopy
+                 IF ( .NOT.  ALLOCATED(pcbinswdif_av) )  THEN
+                     ALLOCATE( pcbinswdif_av(1:npcbl) )
+                     pcbinswdif_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_rad_pc_inswref' )
+!--                 array of of reflected sw radiation absorbed in plant canopy
+                 IF ( .NOT.  ALLOCATED(pcbinswref_av) )  THEN
+                     ALLOCATE( pcbinswref_av(1:npcbl) )
+                     pcbinswref_av = 0.0_wp
+                 ENDIF
+
+             CASE ( 'rtm_mrt_sw' )
                 IF ( .NOT. ALLOCATED( mrtinsw_av ) )  THEN
                    ALLOCATE( mrtinsw_av(nmrtbl) )
@@ -8744,5 +8943,5 @@
                 mrtinsw_av = 0.0_wp
 
-             CASE ( 'rad_mrt_lw' )
+             CASE ( 'rtm_mrt_lw' )
                 IF ( .NOT. ALLOCATED( mrtinlw_av ) )  THEN
                    ALLOCATE( mrtinlw_av(nmrtbl) )
@@ -8750,5 +8949,5 @@
                 mrtinlw_av = 0.0_wp
 
-             CASE ( 'rad_mrt' )
+             CASE ( 'rtm_mrt' )
                 IF ( .NOT. ALLOCATED( mrt_av ) )  THEN
                    ALLOCATE( mrt_av(nmrtbl) )
@@ -8763,6 +8962,6 @@
     ELSEIF ( mode == 'sum' )  THEN
 
-       SELECT CASE ( TRIM( variable ) )
-
+       SELECT CASE ( TRIM( var ) )
+!--       block of large scale (e.g. RRTMG) radiation output variables
           CASE ( 'rad_net*' )
              IF ( ALLOCATED( rad_net_av ) ) THEN
@@ -8971,4 +9170,129 @@
              ENDIF
 
+!--       block of RTM output variables
+          CASE ( 'rtm_rad_net' )
+!--           array of complete radiation balance
+              DO isurf = dirstart(ids), dirend(ids)
+                 IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                    surfradnet_av(isurf) = surfinsw(isurf) - surfoutsw(isurf) +  surfinlw(isurf) - surfoutlw(isurf)
+                 ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_insw' )
+!--           array of sw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinsw_av(isurf) = surfinsw_av(isurf) + surfinsw(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inlw' )
+!--           array of lw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinlw_av(isurf) = surfinlw_av(isurf) + surfinlw(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inswdir' )
+!--           array of direct sw radiation falling to surface from sun
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinswdir_av(isurf) = surfinswdir_av(isurf) + surfinswdir(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inswdif' )
+!--           array of difusion sw radiation falling to surface from sky and borders of the domain
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinswdif_av(isurf) = surfinswdif_av(isurf) + surfinswdif(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_inswref' )
+!--           array of sw radiation falling to surface from reflections
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinswref_av(isurf) = surfinswref_av(isurf) + surfinsw(isurf) - &
+                                          surfinswdir(isurf) - surfinswdif(isurf)
+                  ENDIF
+              ENDDO
+
+
+          CASE ( 'rtm_rad_inlwdif' )
+!--           array of sw radiation falling to surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinlwdif_av(isurf) = surfinlwdif_av(isurf) + surfinlwdif(isurf)
+                  ENDIF
+              ENDDO
+!
+          CASE ( 'rtm_rad_inlwref' )
+!--           array of lw radiation falling to surface from reflections
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinlwref_av(isurf) = surfinlwref_av(isurf) + &
+                                          surfinlw(isurf) - surfinlwdif(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_outsw' )
+!--           array of sw radiation emitted from surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfoutsw_av(isurf) = surfoutsw_av(isurf) + surfoutsw(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_outlw' )
+!--           array of lw radiation emitted from surface after i-th reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfoutlw_av(isurf) = surfoutlw_av(isurf) + surfoutlw(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_ressw' )
+!--           array of residua of sw radiation absorbed in surface after last reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfins_av(isurf) = surfins_av(isurf) + surfins(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_reslw' )
+!--           array of residua of lw radiation absorbed in surface after last reflection
+              DO isurf = dirstart(ids), dirend(ids)
+                  IF ( surfl(id,isurf) == idsint_u  .OR.  surfl(id,isurf) == idsint_l )  THEN
+                      surfinl_av(isurf) = surfinl_av(isurf) + surfinl(isurf)
+                  ENDIF
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_inlw' )
+              DO l = 1, npcbl
+                 pcbinlw_av(l) = pcbinlw_av(l) + pcbinlw(l)
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_insw' )
+              DO l = 1, npcbl
+                 pcbinsw_av(l) = pcbinsw_av(l) + pcbinsw(l)
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_inswdir' )
+              DO l = 1, npcbl
+                 pcbinswdir_av(l) = pcbinswdir_av(l) + pcbinswdir(l)
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_inswdif' )
+              DO l = 1, npcbl
+                 pcbinswdif_av(l) = pcbinswdif_av(l) + pcbinswdif(l)
+              ENDDO
+
+          CASE ( 'rtm_rad_pc_inswref' )
+              DO l = 1, npcbl
+                 pcbinswref_av(l) = pcbinswref_av(l) + pcbinsw(l) - pcbinswdir(l) - pcbinswdif(l)
+              ENDDO
+
           CASE ( 'rad_mrt_sw' )
              IF ( ALLOCATED( mrtinsw_av ) )  THEN
@@ -8993,6 +9317,6 @@
     ELSEIF ( mode == 'average' )  THEN
 
-       SELECT CASE ( TRIM( variable ) )
-
+       SELECT CASE ( TRIM( var ) )
+!--       block of large scale (e.g. RRTMG) radiation output variables
           CASE ( 'rad_net*' )
              IF ( ALLOCATED( rad_net_av ) ) THEN
